def project = 'opticca-k8s-testbed'
def  appName = 'starhopper-analytics'
def  imageRepo = "gcr.io/${project}/${appName}"
def  imageTag  = "${env.BUILD_NUMBER}"

pipeline {
  agent {
    kubernetes {
      label 'starhopper-analytics'
      defaultContainer 'jnlp'
      yaml """
apiVersion: v1
kind: Pod
metadata:
labels:
  component: ci
spec:
  # Use service account that can deploy to all namespaces
  serviceAccountName: cd-jenkins
  containers:
  - name: gcloud
    image: gcr.io/cloud-builders/gcloud
    command:
    - cat
    tty: true
  - name: kubectl
    image: gcr.io/cloud-builders/kubectl
    command:
    - cat
    tty: true
  - name: helm
    image: ibmcom/k8s-helm:v2.6.0
    command:
    - cat
    tty: true
"""
}
  }
  
  
  
  stages {
    stage('Preflight-checks') {
            steps {
                sh 'git --version'
                sh 'javac -version'
                sh 'java -version'
            }
        }

       stage('Build and push image with Container Builder') {
      steps {
        container('gcloud') {
          sh "PYTHONBUFFERED=1 gcloud builds submit -t ${imageRepo}:${imageTag} ."
        }
      }
    }

stage('Build Docker Image') {
            when {
                branch 'master'
            }
            steps {
                script {
                   echo 'Building..'
                    app = docker.build("sarab321/test-pipeline")
                    app.inside {
                        sh 'echo $(curl localhost:8080)'
                    }
                }
            }
        }

      
     /* stage('Deploy Production') {
      // Production branch
      when { branch 'master' }
      steps{
        container('kubectl') {
        // Change deployed image in canary to the one we just built
          sh("sed -i.bak 's#gcr.io/${project}/${appName}:${env.BUILD_NUMBER}#${imageTag}#' starhopper.yml")
          echo 'yaml file read successfully'
          sh("kubectl apply -f starhopper.yml")
          echo 'kubecl get svc'
          sh("echo http://`kubectl --namespace=default get service/${appName} -o jsonpath='{.status.loadBalancer.ingress[0].ip}'` > ${appName}")
        }
      }
    }  */
    
      stage('Deploy Staging') {
      // Staging branch
      when { branch 'master' }
      steps{
        container('helm') {
        // Change deployed image in canary to the one we just built
          sh("/helm init --client-only --skip-refresh")
          sh("/helm upgrade --install starhopper-analytics --set feApp.image.tag=${env.BUILD_NUMBER} ./helmcharts/starhopper-analytics")
              }
      }
    }  
    
}
}
